
// Initialises variables to perform the serial read.
char rx_byte = 0;
String rx_str = "";

String ledChannelStr = "";
String ledBrightnessStr = "";
int ledChannel = 0;
int ledBrightness = 0;

bool endChannel = false;
bool endLine = false;
bool newData = false;

// Includes the TLC5940 library
#include "Tlc5940.h"


void setup() {
  Serial.begin(9600); // Begins the serial
  Tlc.init(); // And initialises the multiplexers
}


// Loop
void loop() {

    
    receiveData(); // Reads the Serial to receive new data
    
    // Since 3 multiplexers are 48 channels, but the sphere has 49, 
    // the 49th uses a normal PWM Arduino pin
    if(ledChannel<48) {

      // Sets the received LED to the received brightness
      Tlc.set(ledChannel, ledBrightness);  
      // Updates the multiplexers     
      Tlc.update(); 
      
    } else if (ledChannel == 48) {
      
      // The PWM resolution is different. Thus, it maps the value
      ledBrightness = map(ledBrightness,0,4096,0,255); 
      // Since there is constant 5v to the LEDs, it outputs the contrary to compensate
      analogWrite(8,abs(ledBrightness-255)); 
    }
    
    newData = false; // Sets "newdata" to false, to start again
}




// Receive new data from the Serial port
void receiveData() {

    while (newData == false) {
      if (Serial.available() > 0) {    // is there a character available?
        rx_byte = Serial.read();       // get the character
      
        // check if a number was received
        if ((rx_byte >= '0') && (rx_byte <= '9')) {
          
          if (endChannel == false) {
            ledChannelStr += rx_byte; //Stores the LED channel first
          } else if (endLine == false) {
            ledBrightnessStr += rx_byte; // And the Brightness
          }
          
        }
        else if (rx_byte == ',') { 
          // When it receives a "," the program knows that all the channel information is done
          endChannel = true;
          ledChannel = ledChannelStr.toInt(); // Saves the channel number
          ledChannelStr = "";
        }
         else if (rx_byte == '\n') {
          // When it receives a "\n" the program knows that the message is done
          newData = true;
          endChannel = false;
          ledBrightness = ledBrightnessStr.toInt(); // Saves the brightness
          ledBrightnessStr = "";
        }
      } 
    }
}
